/**
  Generated Main Source File
    16F18326_7seg_Env_Timer Rev.4 : Timeset by Rotary Encoder

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18326
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include "i2c-lib.h"

// Pin̒`t(74HC595 - PIC)
#define SCK RA4
#define SDI RA0
#define LATCH RA5
#define SHT31_ADDR 0x8A         // SHT31  X[uAhX`:0b1000101(0x45)+0 = 0b10001010 = 0x8A 
#define RTC8564_ADDR 0xA2       // RTC8564X[uAhX`:0b1010001(0x51)+0 = 0b10100010 = 0xA2 
#define SW1 RC5                 // [h؂ւXCb`
#define SW2 RC4                 // /ݒ؂ւXCb` [^[GR[_
#define RE_A RC3                // [^[GR[_(A)
#define RE_B RC2                // [^[GR[_(B)

// O[oϐ錾
const unsigned int Seg[] = {
  0xFC,       // 0
  0x60,       // 1
  0xDA,       // 2
  0xF2,       // 3
  0x66,       // 4
  0xB6,       // 5
  0xBE,       // 6
  0xE0,       // 7
  0xFE,       // 8
  0xF6,       // 9
  0x00        //   
};

unsigned long St,Srh;           // xx16bitf[^i[pϐ
unsigned long data[6];          // SHT31WX^Mf[^i[pϐ
unsigned long TM10,TM01,HU10,HU01;      // TN10:x(10̌),TN01:x(1̌),HU10:x(10̌),HU01:x(1̌)
unsigned long H10,H01,M10,M01;          // H10:(10̌),H01:(1̌),M10:(10̌),M01:(1̌)
unsigned long Sec,Min,Hour;             // b,,
unsigned long Temp,Humi;                // Temp:xϐ,Humi:xϐ
unsigned long Count;                     // wϐ
unsigned int SetFlag;           // ԃZbg؂ւptO
unsigned int State;             // ݒ؂ւtO
unsigned long RECount;           // [^[GR[_JEgl

// vg^CsO錾
void CurDisp(void);             // x/\֐
void RTC8564_INIT(void);        // RTC֐
void SHT31(void);               // xZT[֐
void Conv(void);                // xlϊ֐
void RTC(void);                 // ԃVAo͊֐
void Serial(void);              // ptoVAϊ֐
void TimeSet_Ini(void);         // ݒ菉\֐ 
void TimeSet_Hour(void);        // ݒ\֐uv
void TimeSet_Min(void);        // ݒ\֐uv
void Conv(void);                // lϊ֐
int RE(void);                   // [^[GR[__GR[h֐

/*
 Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    
    __delay_ms(1000);           // UqUJn҂:1sec(RTCO)    

    // foCX
    RTC8564_INIT();             // RTC(荞݋O)        
    
    // ϐ    
    Sec = 0;
    Min = 0;
    Hour = 0;              
    SetFlag = 0;    
    State = 0xFF;
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code
        if(SetFlag == 0) {              // SetFlag:0(݂̉x/\)  
            CurDisp();                  // x/\֐Ăяo
            
            if(SW1 == 0) {              // ݒ SW1I            
                PORTA = 0b00000110;     // [^[GR[_LED+IW_
                SetFlag = 1;            // SetFlag -> 1                
                GIE = 0;                // O[o荞݋֎~
                State = 0xFF;           // StateZbg
                Min = 0;                // Zbg
                Hour = 0;               // Zbg                              
                
                while (SW1 == 0)        // `^O        
                __delay_ms(25);                   

                TimeSet_Ini();          // ݒ菉\֐Ăяo                
            }        
        }

        else {
            if(SW2 == 0) {                  // I SW2I            
                State++;                    // StateJEgAbv                    
                
                if (State > 2)              // State > 2Ȃ       
                    State = 0;              // StateZbg                
                while (SW2 == 0)            // `^O        
                __delay_ms(25);                                       
            }
                
            switch(State) {                     // State
                case 0:

                    RECount = 0;            // RECountZbg
                    while (State == 0)
                    {
                        PORTA = 0b00000010;     // [^[GR[_LED_
                        RECount += RE();        // [^[GR[_JEg(4{l)
                        Hour = RECount / 4;      // 1{lɊZĕϐHourɑ                        

                        if (Hour >= 24) {        // Hour24Ȃ
                            Hour = 0;           // HourZbg
                            RECount = 0;      // RECountZbg
                        }                        

                        if (Hour == 0)          // Hour0Ȃ                        
                            Hour = 0;           // HourZbg

                        TimeSet_Hour();         // ݒ\֐uvĂяo
                        
                        if(SW2 == 0)
                            break;                        
                    }                        
                    break;

                case 1:                

                    RECount = 0;            // RECountZbg
                    while (State == 1)
                    {
                        PORTA = 0b00000100;     // [^[GR[_LED_
                        RECount += RE();        // [^[GR[_JEg(4{l)
                        Min = RECount / 4;      // 1{lɊZĕϐMinɑ                        

                        if (Min >= 60) {        // Min60Ȃ
                            Min = 0;           // MinZbg
                            RECount = 0;      // RECountZbg
                        }                        

                        if (Min == 0)          // Min0Ȃ                        
                            Min = 0;           // MinZbg                                                  

                        TimeSet_Min();          // ݒ\֐uvĂяo

                        if(SW2 == 0)
                            break;                        
                    }
                    break;

                case 2:

                    PORTA = 0b00000110;     // [^[GR[_LED+IW_
                    TimeSet_Min();          // ݒ\֐uvĂяo
                    
                    if(SW1 == 0) {          // SW1(ԃZbg)IH            
                        Sec = 0;            // ubvZbg
                        SetFlag = 0;        // SetFlag=0(݂̉x/\)ɐ؂ւ
                        GIE = 1;            // O[o荞݋

                        while (SW1 == 0)    // `^O        
                        __delay_ms(25);                            

                        PORTA = 0;          // [^[GR[_LED
                    }
                    break;
                                
                default:break;
            }                                
        }
    }        
}

// x/\֐
void CurDisp(void) {

        SHT31();            // xZT[֐Ăяo
        RTC();              // ԃVAo͊֐Ăяo
       
        LATCH = 1;          // b`[X
        LATCH = 0;
}

// xZT[֐
void SHT31(void) {
// FxuvANbNXgb`

    unsigned int i;

// R}hM    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR);      // X[uAhXw
    i2c_send_byte(0x24);            // R}h(MSB) = 0x24 : NbNXgb`
    i2c_send_byte(0x0B);            // R}h(LSB) = 0x0B : x   
    i2c_stop();                     // I2CXgbvRfBVs     

    __delay_ms(5);                  // ҂ (x:m~i 4.5 msec)

// xf[^ǂݏo    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR + 1);  // X[uID + 1(ǂݍݗv)
    for (i=0; i<6; i++)             // f[^荞
    {
        if (i == 5)
            data[5] = i2c_read_byte(0);     // ŏIWX^MNACK
        else
            data[i] = i2c_read_byte(1);     // ȊO͎MACKԂ   
    }

    i2c_stop();             // I2CXgbvRfBVs     

    Conv();                 // xlϊ֐Ăяo
    
    __delay_ms(100);    // h~    
}

// xlϊ֐
void Conv(void) {
// xZFT = -45 + 175 * St / (2^16-1)    
// x16bit(MSB+LSB)2i10iɕϊ
    St = (data[0] << 8) | data[1];          // x16bit(MSB+LSB) 
    Temp = St * 175 / 65535 - 45;           // 2^16-1 = 65535
    
// xZFRH = 100 * Srh / (2^16-1)
// x16bit(MSB+LSB)2i10iɕϊ
    Srh = (data[3] << 8) | data[4];          // x16bit(MSB+LSB)
    Humi = Srh * 100 / 65535;                //         
    
// CRC͏Ȃ()

    TM10 = Temp / 10;       // x(10̌)
        Count = TM10;       // Seg[]w
            Serial();       // VAϊ֐Ăяo

    TM01 = Temp % 10;       // x(1̌)    
        Count = TM01;       // Seg[]w
            Serial();       // VAϊ֐Ăяo

    HU10 = Humi / 10;       // x(10̌)
        Count = HU10;       // Seg[]w
            Serial();       // VAϊ֐Ăяo        

    HU01 = Humi % 10;       // x(1̌)        
        Count = HU01;       // Seg[]w
            Serial();       // VAϊ֐Ăяo                
}

// RTC֐
void RTC8564_INIT(void) {

// eWX^ݒ    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(RTC8564_ADDR);    // X[uAhXw

    i2c_send_byte(0x00);            // 擪AhXw(ȉI[gCNg)

    i2c_send_byte(0);               // AhX(0x00):Rg[WX^ 1 ݒ
    i2c_send_byte(0);               // AhX(0x01):Rg[WX^ 2 ݒ
    i2c_send_byte(0);               // AhX(0x02):vJE^ b     
    i2c_send_byte(0);               // AhX(0x03):vJE^          
    i2c_send_byte(0);               // AhX(0x04):vJE^      
    i2c_send_byte(0);               // AhX(0x05):J_[JE^    
    i2c_send_byte(0);               // AhX(0x06):J_[JE^ j     
    i2c_send_byte(0);               // AhX(0x07):J_[JE^         
    i2c_send_byte(0);               // AhX(0x08):J_[JE^ N     
    i2c_send_byte(0x80);            // AhX(0x09):A[   (AErbg=1) 
    i2c_send_byte(0x80);            // AhX(0x0A):A[   (AErbg=1)    
    i2c_send_byte(0x80);            // AhX(0x0B):A[   (AErbg=1)   
    i2c_send_byte(0x80);            // AhX(0x0C):A[ j  (AErbg=1)     
    i2c_send_byte(0x83);            // AhX(0x0D):CLKOUT= 1 Hz AEgvbgݒ (0b10000011)
    i2c_send_byte(0);               // AhX(0x0E):^C}荞ݒ~ (TFrbg=0)        
    i2c_send_byte(0);               // AhX(0x0F):^C} ݒ    
    
    i2c_stop();                     // I2CXgbvRfBVs         
}

// ԃVAo͊֐
void RTC(void) {
    H10 = Hour / 10;                // (10̌)
        Count = H10;                // Seg[]w
            Serial();               // VAϊ֐Ăяo

    H01 = Hour % 10;                // (1̌)    
        Count = H01;                // Seg[]w
            Serial();               // VAϊ֐Ăяo

    M10 = Min / 10;                 // (10̌)
        Count = M10;                // Seg[]w
            Serial();               // VAϊ֐Ăяo        

    M01 = Min % 10;                 // (1̌)        
        Count = M01;                // Seg[]w
            Serial();               // VAϊ֐Ăяo            
}               

// ptoVAϊ֐
void Serial(void) {

    unsigned int i;    
    
    for (i=0; i<8; i++)
    {
        if (((Seg[Count] >> i) & 1) == 1)     // Segf[^̃rbg
            SDI = 1;
        else        
            SDI = 0;        

        SCK = 1;            // VtgWX^[ɃrbgZbg
        SCK = 0;
    }
}

// ݒ菉\֐
void TimeSet_Ini(void) {
 
    Count = 10; 

    Serial();
    Serial();
    Serial();
    Serial();

    Count = 0; 

    Serial();
    Serial();
    Serial();
    Serial(); 

    LATCH = 1;          // b`[X
    LATCH = 0; 
} 
 
// ݒ\֐uv
void TimeSet_Hour(void) {
 
    Count = 10; 

    Serial();
    Serial();
    Serial();
    Serial();

    H10 = Hour / 10;                // (10̌)
        Count = H10;                // Seg[]w
            Serial();               // VAϊ֐Ăяo

    H01 = Hour % 10;                // (1̌)    
        Count = H01;                // Seg[]w
            Serial();               // VAϊ֐Ăяo
 
    Count = 10;
  
    Serial();
    Serial(); 

    LATCH = 1;          // b`[X
    LATCH = 0; 
}  

// ݒ\֐uv
void TimeSet_Min(void) {
 
    Count = 10; 

    Serial();
    Serial();
    Serial();
    Serial();

    H10 = Hour / 10;                // (10̌)
        Count = H10;                // Seg[]w
            Serial();               // VAϊ֐Ăяo

    H01 = Hour % 10;                // (1̌)    
        Count = H01;                // Seg[]w
            Serial();               // VAϊ֐Ăяo
            
    M10 = Min / 10;                 // (10̌)
        Count = M10;                // Seg[]w
            Serial();               // VAϊ֐Ăяo        

    M01 = Min % 10;                 // (1̌)        
        Count = M01;                // Seg[]w
            Serial();               // VAϊ֐Ăяo    

    LATCH = 1;          // b`[X
    LATCH = 0; 
} 

// [^[GR[__GR[h֐
int RE(void) {
    static const int Dir[] = {0,1,-1,0,-1,0,0,1,1,0,0,-1,0,-1,1,0};     // ]e[u (0:ωȂ, 1:CW, -1:CCW)
    static int Prev;                // Õ[^[GR[_li[ϐ(static^Œlێ)
    unsigned int Curr;              // ݂̃[^[GR[_li[ϐ
    unsigned int index;             // Dir[]QƗpCfbNX
    Curr = (RE_B << 1) + RE_A;      // ݂̃[^[GR[_Ԃǂݍ <1:0>
    Prev <<= 2;                     // Ol2rbgVtg <3:2> 
    Prev |= (Curr & 0x03);          // Ol2rbg <3:2>ƌݒl2rbg <1:0>
    index = Prev & 0x0F;            // 4rbg <3:0>vCfbNXl
    return (Dir[index]);            // CfbNXDir[]ƍlԂ
}

/**
 End of File
*/